%define pcre_prefix     /usr/local/openresty/pcre
%define pcre_prefix_asan	/usr/local/openresty-asan/pcre

Summary:            Perl-compatible regular expression library for OpenResty
Name:               openresty-pcre
Version:            8.45
Release:            6%{?dist}
License:            BSD
URL:                https://openresty.org/
Source0:            https://sourceforge.net/projects/pcre/files/pcre/%{version}/pcre-%{version}.tar.bz2
Patch3000:          copy-dir.patch

BuildRequires:      ccache, libtool
AutoReqProv:        no


%description
Perl-compatible regular expression library for use by OpenResty ONLY


%package devel
Summary:            Development files for %{name}
Requires:           %{name} = %{version}-%{release}


%description devel
Development files for Perl-compatible regular expression library for use by OpenResty ONLY

%package asan
Summary:            Clang AddressSanitizer version of the Perl-compatible regular expression library for OpenResty
BuildRequires:      libasan, ccache, libtool, clang, compiler-rt
AutoReqProv:        no


%description asan
Perl-compatible regular expression library for use by OpenResty ONLY.
This is the clang AddressSanitizer version.

%package asan-devel
Summary:            Development files for openresty-pcre-asan
Requires:           openresty-pcre-asan = %{version}-%{release}


%description asan-devel
Development files for Perl-compatible regular expression library for use by OpenResty ONLY.
This is the clang AddressSanitizer version.

%prep
%autosetup -p1 -n pcre-%{version}
%ifarch loongarch64
autoreconf -fiv
%endif

%build
bash ./copy-dir.sh
export CC="ccache gcc -fdiagnostics-color=always"

./configure \
  --prefix=%{pcre_prefix} \
  --libdir=%{pcre_prefix}/lib \
  --disable-cpp \
%ifnarch loongarch64
  --enable-jit \
%endif
  --enable-utf \
  --enable-unicode-properties

make -j`nproc` V=1 > /dev/stderr

cd asan
export CC="ccache gcc -fsanitize=address"
export CFLAGS="-fPIC -fPIE -O1 -fno-omit-frame-pointer -g"
export ASAN_OPTIONS=detect_leaks=0

./configure \
  --prefix=%{pcre_prefix_asan} \
  --libdir=%{pcre_prefix_asan}/lib \
  --disable-cpp \
%ifnarch loongarch64
  --enable-jit \
%endif
  --enable-utf \
  --enable-unicode-properties

make -j`nproc` V=1 > /dev/stderr
cd -


%install
make install DESTDIR=%{buildroot}
rm -rf %{buildroot}/%{pcre_prefix}/bin
rm -rf %{buildroot}/%{pcre_prefix}/share
rm -f  %{buildroot}/%{pcre_prefix}/lib/*.la
rm -f  %{buildroot}/%{pcre_prefix}/lib/*pcrecpp*
rm -f  %{buildroot}/%{pcre_prefix}/lib/*pcreposix*
rm -rf %{buildroot}/%{pcre_prefix}/lib/pkgconfig

cd asan
make install DESTDIR=%{buildroot}
rm -rf %{buildroot}/%{pcre_prefix_asan}/bin
rm -rf %{buildroot}/%{pcre_prefix_asan}/share
rm -f  %{buildroot}/%{pcre_prefix_asan}/lib/*.la
rm -f  %{buildroot}/%{pcre_prefix_asan}/lib/*pcrecpp*
rm -f  %{buildroot}/%{pcre_prefix_asan}/lib/*pcreposix*
rm -rf %{buildroot}/%{pcre_prefix_asan}/lib/pkgconfig



%files
%defattr(-,root,root,-)
%dir %{pcre_prefix}
%dir %{pcre_prefix}/lib
%{pcre_prefix}/lib/*.so*


%files devel
%dir %{pcre_prefix}/include
%defattr(-,root,root,-)
%{pcre_prefix}/lib/*.a
%{pcre_prefix}/include/*.h


%files asan
%defattr(-,root,root,-)
%dir %{pcre_prefix_asan}
%dir %{pcre_prefix_asan}/lib
%{pcre_prefix_asan}/lib/*.so*


%files asan-devel
%defattr(-,root,root,-)
%dir %{pcre_prefix_asan}/include
%{pcre_prefix_asan}/lib/*.a
%{pcre_prefix_asan}/include/*.h

%changelog
* Wed Apr 10 2024 Pengda Dou <doupengda@loongson.cn> - 8.45-6
- add support for loongarch64

* Fri Feb 02 2024 kianli <kianli@tencent.com> - 8.45-5
- set AutoReqProv no for asan subpackage

* Wed Jan 31 2024 Feng Weiyao <wynnfeng@tencent.com> - 8.45-4
- set AutoReqProv no

* Mon Dec 25 2023 luffyluo <luffyluo@tencent.com> - 8.45-3
- Rebuilt for llvm 17.0.6

* Fri Dec 8 2023 Feng Weiyao <wynnfeng@tencent.com> - 8.45-2
- initial build for opencloudos 

* Wed Jan 26 2022 Yichun Zhang (agentzh) 8.45-1
- upgraded PCRE to 8.45.

* Mon May 14 2018 Yichun Zhang (agentzh) 8.42-1
- upgraded openresty-pcre to 8.42.

* Thu Nov 2 2017 Yichun Zhang (agentzh)
- upgraded PCRE to 8.41.

* Sun Mar 19 2017 Yichun Zhang (agentzh)
- upgraded PCRE to 8.40.

* Sat Sep 24 2016 Yichun Zhang
- disable the C++ support in build. thanks luto.

* Tue Aug 23 2016 zxcvbn4038
- initial build for pcre 8.39.
